%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%define __debug_install_post %{_mingw32_debug_install_post}

%global bin_version 3.0.0
# first two digits of version
%define release_version %(echo %{version} | awk -F. '{print $1"."$2}')

Name:           mingw-gtk3
Version:        3.0.12
Release:        1%{?dist}
Summary:        MinGW Windows GTK+ library

License:        LGPLv2+
Group:          Development/Libraries
URL:            http://www.gtk.org
Source0:        http://download.gnome.org/sources/gtk+/%{release_version}/gtk+-%{version}.tar.xz
# wine gtk-query-immodules-3.0.exe > gtk.immodules
Source1:        gtk.immodules
# Fix multiple symbol definitions in gtk/gtkmarshalers.c and perf/marshalers.c
# https://bugzilla.gnome.org/show_bug.cgi?id=648926
Patch0:         mingw32-gtk3-perf_marshal.patch
# Disable gtk-update-icon-cache.exe.manifest with --enable-gtk2-dependency
# https://bugzilla.gnome.org/show_bug.cgi?id=648938
Patch1:         mingw32-gtk3-manifest.patch
# Fix linking with libuuid
# https://bugzilla.gnome.org/show_bug.cgi?id=642214
Patch2:         mingw32-gtk3-libuuid.patch
# Install missing gdk/win32/ headers
Patch3:         mingw32-gtk3-gdk_headers.patch

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 68
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils

BuildRequires:  mingw32-atk
BuildRequires:  mingw32-cairo
BuildRequires:  mingw32-dlfcn
BuildRequires:  mingw32-gdk-pixbuf
BuildRequires:  mingw32-gettext
BuildRequires:  mingw32-glib2
BuildRequires:  mingw32-iconv
BuildRequires:  mingw32-pango
BuildRequires:  mingw32-pixman
BuildRequires:  mingw32-zlib

# Native one for msgfmt
BuildRequires:  gettext
# Native one for glib-genmarshal
BuildRequires:  glib2-devel
# Native one for gtk-update-icon-cache
BuildRequires:  gtk2
# Native one for gdk-pixbuf-csource
BuildRequires:  gdk-pixbuf2-devel

%description
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

This package contains the MinGW Windows cross compiled GTK+ 3 library.


%package -n mingw32-gtk3
Summary:        MinGW Windows GTK+ library
Requires:       pkgconfig

%description -n mingw32-gtk3
GTK+ is a multi-platform toolkit for creating graphical user
interfaces. Offering a complete set of widgets, GTK+ is suitable for
projects ranging from small one-off tools to complete application
suites.

This package contains the MinGW Windows cross compiled GTK+ 3 library.


%{?_mingw32_debug_package}


%prep
%setup -q -n gtk+-%{version}
%patch0 -p1 -b .perf_marshal
%patch1 -p1 -b .manifest
%patch2 -p1 -b .libuuid
%patch3 -p1 -b .gdk_headers


%build
%{_mingw32_configure} \
  --enable-gtk2-dependency \
  --disable-cups

make %{?_smp_mflags} V=1


%install
make install DESTDIR=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT/%{_mingw32_libdir}/charset.alias

# Remove manpages which duplicate those in Fedora native.
rm -rf $RPM_BUILD_ROOT%{_mingw32_mandir}

# Remove documentation too.
rm -rf $RPM_BUILD_ROOT%{_mingw32_datadir}/gtk-doc

# Remove unneeded files
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/*.def
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/modules/*.dll.a
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/modules/*.la
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/%{bin_version}/engines/*.dll.a
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/%{bin_version}/engines/*.la
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/*.dll.a
rm -f $RPM_BUILD_ROOT%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/*.la

# Install the gtk.immodules file
mkdir -p $RPM_BUILD_ROOT%{_mingw32_sysconfdir}/gtk-3.0/
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_mingw32_sysconfdir}/gtk-3.0/

%find_lang %{name} --all-name


%postun -n mingw32-gtk3
if [ $1 -eq 0 ] ; then
    /usr/bin/glib-compile-schemas %{_mingw32_datadir}/glib-2.0/schemas &> /dev/null || :
fi

%posttrans -n mingw32-gtk3
/usr/bin/glib-compile-schemas %{_mingw32_datadir}/glib-2.0/schemas &> /dev/null || :


%files -n mingw32-gtk3 -f %{name}.lang
%doc COPYING
%{_mingw32_bindir}/gtk3-demo.exe
%{_mingw32_bindir}/gtk-query-immodules-3.0.exe
%{_mingw32_bindir}/libgdk-3-0.dll
%{_mingw32_bindir}/libgailutil-3-0.dll
%{_mingw32_bindir}/libgtk-3-0.dll
%{_mingw32_sysconfdir}/gtk-3.0/
%{_mingw32_includedir}/gtk-3.0/
%{_mingw32_includedir}/gail-3.0/
%dir %{_mingw32_libdir}/gtk-3.0
%dir %{_mingw32_libdir}/gtk-3.0/%{bin_version}
%dir %{_mingw32_libdir}/gtk-3.0/%{bin_version}/engines
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/engines/libwimp.dll
%dir %{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-am-et.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-cedilla.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-cyrillic-translit.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ime.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-inuktitut.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ipa.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-multipress.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-thai.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-er.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-ti-et.dll
%{_mingw32_libdir}/gtk-3.0/%{bin_version}/immodules/im-viqr.dll
%dir %{_mingw32_libdir}/gtk-3.0/modules
%{_mingw32_libdir}/gtk-3.0/modules/libgail.dll
%{_mingw32_libdir}/libgailutil-3.dll.a
%{_mingw32_libdir}/libgailutil-3.la
%{_mingw32_libdir}/libgdk-3.dll.a
%{_mingw32_libdir}/libgdk-3.la
%{_mingw32_libdir}/libgtk-3.dll.a
%{_mingw32_libdir}/libgtk-3.la
%{_mingw32_libdir}/pkgconfig/gail-3.0.pc
%{_mingw32_libdir}/pkgconfig/gdk-3.0.pc
%{_mingw32_libdir}/pkgconfig/gdk-win32-3.0.pc
%{_mingw32_libdir}/pkgconfig/gtk+-3.0.pc
%{_mingw32_libdir}/pkgconfig/gtk+-win32-3.0.pc
%{_mingw32_datadir}/aclocal/gtk-3.0.m4
%{_mingw32_datadir}/glib-2.0/schemas/org.gtk.Settings.FileChooser.gschema.xml
%{_mingw32_datadir}/gtk-3.0/
%{_mingw32_datadir}/themes/*


%changelog
* Sat Jul 30 2011 Kalev Lember <kalevlember@gmail.com> - 3.0.12-1
- Update to 3.0.12
- Added rpm scriplets for running glib-compile-schemas

* Fri Jul 08 2011 Kalev Lember <kalevlember@gmail.com> - 3.0.11-1
- Update to 3.0.11
- Install missing gdk/win32/ headers, patch by Greg Hellings (#718802)

* Mon May 23 2011 Kalev Lember <kalev@smartlink.ee> - 3.0.10-1
- Update to 3.0.10
- Renamed the base package to mingw-gtk3
- Use the automatic dep extraction available in mingw32-filesystem 68

* Mon May 02 2011 Kalev Lember <kalev@smartlink.ee> - 3.0.9-3
- Backported an upstream patch for linking with libuuid

* Fri Apr 29 2011 Kalev Lember <kalev@smartlink.ee> - 3.0.9-2
- Removed an unneeded PATH override (#700815)

* Fri Apr 29 2011 Kalev Lember <kalev@smartlink.ee> - 3.0.9-1
- Initial RPM release
